/************************************************************************
*  AutoDiffExample.C (Test example for automatic differentiation type)
*
*  Version:                     1.5
*  Date:                        2/1/94
*  Author:                      O. Knueppel
*************************************************************************/

#include "autodiff.h"

AUTODIFF f(VECTOR & v)
{
  AUTODIFF x(v); // x is the independent variable

  return x(1) + Sqr(x(2));
}

INT main()
{
  VECTOR v(2);
  v(1) = 10.0; v(2) = 20.0;

  AUTODIFF::ComputeHessian = 1;

  AUTODIFF y;

  y = f(v); // compute values of function, gradient, and hessian

  cout << "f(x,y) = x + y^2, x = 10, y = 20" << endl << endl;
  cout << "f(x,y)        = " << FunctionValue (y) << endl;
  cout << "gradient(x,y) = " << GradientValue (y) << endl;
  cout << "hessian(x,y)  =\n" << HessianValue (y) << endl;
  return 0;
}
