/************************************************************************
*  Brent_Test.C (Simple Test Program for Brent)
*
*  Version:                     1.1
*  Date:                        9/29/93
*  Author:                      O. Knueppel
*************************************************************************/

#include "brent.h"
#include "func.h"
#include "error.h"

REAL f(VECTOR & x)
{
  return Sqr(x(1) - 1.0) + Sqr(x(2) - 2.0) + 1.0;
}

INT main()
{
  VECTOR x(2); x(1) = 6.0; x(2) = -5.0;
  VECTOR diam(2); diam(1) = 20.0; diam(2) = 10.0;
  VECTOR solution(2); solution(1) = 1.0; solution(2) = 2.0;
  REAL tol = 1E-6;
  REAL y;

  y = BrentMinimize (x, diam, tol, tol, f);
  if (Norm (x - solution) > tol) {
    cout << "Brent: x    = " << x  << " should be " << solution << endl;
    cout << "       f(x) = " << y  << " should be " << f(solution) << endl;
    Error ("Problems in Brent_Test", 1, ErrorHandler::SevereError);
  }
  return 0;
}
