/************************************************************************
*  NelderMead_Test.C (Simple Test Program for NelderMead)
*
*  Version:                     1.1
*  Date:                        9/29/93
*  Author:                      O. Knueppel
*************************************************************************/

#include "nelmead.h"
#include "func.h"
#include "error.h"

REAL f(VECTOR & x)
{
  return Sqr(x(1) - 1.0) + Sqr(x(2) - 2.0) + 1.0;
}

INT main()
{
  VECTOR x(2); x(1) = 6.0; x(2) = 3.0;
  VECTOR d(2); d(1) = 20.0; d(2) = 20.0;
  VECTOR solution(2); solution(1) = 1.0; solution(2) = 2.0;
  REAL tol = 1E-12;
  REAL y;
  INT ok;

  y = NelderMead (x, d, tol, tol, ok, 100, f);
  if (!ok || (Norm (x - solution) > sqrt(tol) * 10.0)) {
    cout << "NelderMead: ok   = " << ok << " should be 1" << endl;
    cout << "            x    = " << x  << " should be " << solution << endl;
    cout << "            f(x) = " << y  << " should be " << f(solution) << endl;
    Error ("Problems in NelderMead_Test", 1, ErrorHandler::SevereError);
  }
  return 0;
}
