/************************************************************************
*  BaseTestMatrices.h (Definition of REAL test matrices (C routines))
*
*  Version:                     1.2
*  Date:                        11/15/93
*  Author:                      T. Simenec
*************************************************************************/

#ifndef __BASETESTMATRICES__
#define __BASETESTMATRICES__

#include "config.h"
#ifndef __PORTAB__
#include "Portab.h"
#endif

#if defined (__cplusplus)
extern "C" {
#endif

VOID BaseLietzke (PREAL, INT);

VOID BaseIntPascal (PREAL, INT);

VOID BasePascal (PREAL, INT, REAL);

VOID BaseHilbert (PREAL, INT);

BOOL BaseExactHilbert (PREAL, INT);

VOID BaseInverseHilbert (PREAL, INT);

VOID BaseLotkin (PREAL, INT);

VOID BaseWestlake (PREAL, INT);

VOID BaseNewman (PREAL, INT);

VOID BaseFrank (PREAL, INT);

VOID BaseBoothroydMax (PREAL, INT);

VOID BaseHadamard (PREAL, INT);

VOID BaseBinomial (PREAL, INT);

VOID BaseAergerter (PREAL, INT);

VOID BaseTodd (PREAL, INT);

VOID BaseMilnes (PREAL, PREAL, BOOL, INT);

VOID BaseCombinatorial (PREAL, REAL, REAL, BOOL, INT);

VOID BaseCauchy (PREAL, PREAL, PREAL, BOOL, INT);

VOID BaseVandermonde (PREAL, PREAL, INT);

VOID BaseBoothroyd (PREAL, PREAL, PREAL, INT);

VOID BaseInverseBoothroyd (PREAL, PREAL, PREAL, INT);

VOID BaseRandomM_Matrix (PREAL, PREAL, PREAL, INT);

VOID BaseRandomPD (PREAL, PREAL, PREAL, PREAL, REAL, REAL, BOOL, INT);

VOID BaseRandomSPD (PREAL, PREAL, PREAL, REAL, REAL, BOOL, INT);

VOID BaseRandomToeplitz (PREAL, PREAL, INT);

VOID BaseRandomMatrix (PREAL, INT);

VOID BaseRectRandomMatrix (PREAL, INT, INT);

VOID BaseRandomSymmetric (PREAL, INT);

VOID BaseRandomPersymmetric (PREAL, INT);

#if defined (__cplusplus)
}
#endif

#endif /* __BASETESTMATRICES__ */
